﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// 空白頁項目範本已記錄在 https://go.microsoft.com/fwlink/?LinkId=234238

namespace i8017HW_Basic_Info_Csharp.Pages
{
    /// <summary>
    /// 可以在本身使用或巡覽至框架內的空白頁面。
    /// </summary>
    public sealed partial class I8017HW_I8017HDW_I9017 : Page
    {
        Int16 s17h = -1;
        Int16 jp = 0;
        Int16 maxch = 0;
        Int16 ver = 0;
        Int16 gain=0;
        TextBox[] AI_txt;
        public I8017HW_I8017HDW_I9017()
        {
            this.InitializeComponent();
            AI_txt = new TextBox[16] { C0_txt,C1_txt,C2_txt,C3_txt,C4_txt,C5_txt,C6_txt,C7_txt,C8_txt,C9_txt,C10_txt,C11_txt,C12_txt,C13_txt,C14_txt,C15_txt};
        }

        private void slot_cbx_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            s17h = (Int16)slot_cbx.SelectedIndex;
            if (pac8017HWNet.pac8017HW.Init(s17h) == 0)
            {
                pac8017HWNet.pac8017HW.SingleEndJumper(s17h, ref jp);
                if (jp == 0)
                {
                    maxch = 8;
                    Jumper_txt.Text = "Differential";
                }
                else
                {
                    maxch = 16;
                    Jumper_txt.Text = "Single Ended";
                }
                pac8017HWNet.pac8017HW.FirmwareVersion(s17h, ref ver);
                FW_ver_txt.Text = String.Format("{0:X4}", ver); 
                Range_cbx.SelectedIndex = 0;
                Float_Format_chk.IsChecked = true;
                Status_txt.Text = "Init OK!!";
            }
            else
            {
                Status_txt.Text = "Init Failed!!";
            }
        }

        private void Range_cbx_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            UInt16 gval = 0;
            Int16 oval = 0;
            gain = (Int16)Range_cbx.SelectedIndex;
            pac8017HWNet.pac8017HW.GainOffset_Info(s17h, gain, ref gval, ref oval);
            Gain_txt.Text = gval.ToString();
            Offset_txt.Text = oval.ToString();
        }

        private void Float_Format_chk_Click(object sender, RoutedEventArgs e)
        {
            if (Float_Format_chk.IsChecked.Value == true)
            {
                HEX_Format_chk.IsChecked = false;
            }
            else
            {
                HEX_Format_chk.IsChecked = true;
            }
        }

        private void HEX_Format_chk_Click(object sender, RoutedEventArgs e)
        {
            if (HEX_Format_chk.IsChecked.Value == true)
            {
                Float_Format_chk.IsChecked = false;
            }
            else
            {
                Float_Format_chk.IsChecked = true;
            }
        }

        private void Read_btn_Click(object sender, RoutedEventArgs e)
        {
            Int16 ch = 0;
            Int16 hval = 0;
            float fval=0;
            for (ch = 0; ch < maxch; ++ch)
            {
                if (Float_Format_chk.IsChecked.Value == true)
                {
                    pac8017HWNet.pac8017HW.ReadAI(s17h, ch, gain, ref fval);
                    AI_txt[ch].Text = String.Format("{0:00.000}", fval);
                }
                else
                {
                    pac8017HWNet.pac8017HW.ReadAIHex(s17h, ch, gain, ref hval);
                    AI_txt[ch].Text = String.Format("{0:X4}", hval);
                }
            }
        }
    }
}