﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// 空白頁項目範本已記錄在 https://go.microsoft.com/fwlink/?LinkId=234238

namespace i8017HW_Basic_Info_Csharp.Pages
{
    /// <summary>
    /// 可以在本身使用或巡覽至框架內的空白頁面。
    /// </summary>
    public sealed partial class I9017C_15 : Page
    {
        Int16 s17c_15 = -1;
        Int16 jp = 0;
        Int16 maxch = 15;
        Int16 ver = 0;
        Int16 gain = 4;
        TextBox[] AI_txt;
        TextBox[] G_txt;
        TextBox[] O_txt;
        public I9017C_15()
        {
            this.InitializeComponent();
            AI_txt = new TextBox[15] {
                C0_txt, C1_txt, C2_txt, C3_txt, C4_txt, C5_txt, C6_txt, C7_txt ,
                C8_txt, C9_txt, C10_txt, C11_txt, C12_txt, C13_txt, C14_txt
            };
            G_txt = new TextBox[15] {
                G0_txt, G1_txt, G2_txt, G3_txt, G4_txt, G5_txt, G6_txt, G7_txt ,
                G8_txt, G9_txt, G10_txt, G11_txt, G12_txt, G13_txt, G14_txt
            };
            O_txt = new TextBox[15] { 
                O0_txt, O1_txt, O2_txt, O3_txt, O4_txt, O5_txt, O6_txt, O7_txt ,
                O8_txt, O9_txt, O10_txt, O11_txt, O12_txt, O13_txt, O14_txt
            };
            Jumper_txt.Text = "Always Differential";
        }

        private void slot_cbx_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Int16 ch = 0;
            UInt16 gval = 0;
            Int16 oval = 0;
            s17c_15 = (Int16)slot_cbx.SelectedIndex;
            if (pac8017HWNet.pac8017HW.Init(s17c_15) == 0)
            {
                pac8017HWNet.pac8017HW.FirmwareVersion(s17c_15, ref ver);
                FW_ver_txt.Text = String.Format("{0:X4}", ver);
                for (ch = 0; ch < 15; ++ch)
                {
                    pac8017HWNet.pac8017HW.Ch_mAGainOffset(s17c_15, ch, ref gval, ref oval);
                    G_txt[ch].Text = gval.ToString();
                    O_txt[ch].Text = oval.ToString();
                }
                Float_Format_chk.IsChecked = true;
                Status_txt.Text = "Init OK!!";
            }
            else
            {
                Status_txt.Text = "Init Failed!!";
            }
        }

        private void Float_Format_chk_Click(object sender, RoutedEventArgs e)
        {
            if (Float_Format_chk.IsChecked.Value == true)
            {
                HEX_Format_chk.IsChecked = false;
            }
            else
            {
                HEX_Format_chk.IsChecked = true;
            }
        }

        private void HEX_Format_chk_Click(object sender, RoutedEventArgs e)
        {
            if (HEX_Format_chk.IsChecked.Value == true)
            {
                Float_Format_chk.IsChecked = false;
            }
            else
            {
                Float_Format_chk.IsChecked = true;
            }
        }

        private void Read_btn_Click(object sender, RoutedEventArgs e)
        {
            Int16 ch = 0;
            Int16 hval = 0;
            float fval = 0;
            for (ch = 0; ch < maxch; ++ch)
            {
                if (Float_Format_chk.IsChecked.Value == true)
                {
                    pac8017HWNet.pac8017HW.ReadAI(s17c_15, ch, gain, ref fval);
                    AI_txt[ch].Text = String.Format("{0:00.000}", fval);
                }
                else
                {
                    pac8017HWNet.pac8017HW.ReadAIHex(s17c_15, ch, gain, ref hval);
                    AI_txt[ch].Text = String.Format("{0:X4}", hval);
                }
            }
        }
    }
}
